org.apache.tomcat.util.bcel.classfile

## Class SourceFile

- java.lang.Object
- - org.apache.tomcat.util.bcel.classfile.Attribute
  - - org.apache.tomcat.util.bcel.classfile.SourceFile

All Implemented Interfaces:
  Serializable, Cloneable

    public final class SourceFile
    extends Attribute

This class is derived from Attribute and represents a reference to the source file of this class. At most one SourceFile attribute should appear per classfile. The intention of this class is that it is instantiated from the Attribute.readAttribute() method.

Author:
  M. Dahm
See Also:
  `Attribute`, Serialized Form

### Field Summary

### Fields inherited from class org.apache.tomcat.util.bcel.classfile.Attribute

`constant_pool, length, name_index, tag`

### Constructor Summary

Constructors
Constructor and Description
`SourceFile(int name_index, int length, int sourcefile_index, ConstantPool constant_pool)`

### Method Summary

Methods
`Attribute` `copy(ConstantPool _constant_pool)`
`String` `getSourceFileName()`
`String` `toString()`

### Methods inherited from class org.apache.tomcat.util.bcel.classfile.Attribute

`clone, getName, getTag, readAttribute`

### Methods inherited from class java.lang.Object

`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### SourceFile

    public SourceFile(int name_index,
              int length,
              int sourcefile_index,
              ConstantPool constant_pool)

Parameters:
  `name_index` - Index in constant pool to CONSTANT_Utf8, which should represent the string "SourceFile".
  `length` - Content length in bytes, the value should be 2.
  `constant_pool` - The constant pool that this attribute is associated with.
  `sourcefile_index` - Index in constant pool to CONSTANT_Utf8. This string will be interpreted as the name of the file from which this class was compiled. It will not be interpreted as indicating the name of the directory contqining the file or an absolute path; this information has to be supplied the consumer of this attribute - in many cases, the JVM.

### Method Detail

#### getSourceFileName

    public final String getSourceFileName()

Returns:
  Source file name.

#### toString

    public final String toString()

Overrides:
  `toString` in class `Attribute`
Returns:
  String representation

#### copy

    public Attribute copy(ConstantPool _constant_pool)

Specified by:
  `copy` in class `Attribute`
Returns:
  deep copy of this attribute